library(readr)

# Inputs
## The RNA-seq Dataset 
RNAseq <- read_csv("~/Documents/CSUN/Research/Loza-Coll Lab/Thesis/NetR:AttR Manuscript/Networks/Dutta/physiological-GSE61361_processed_data.csv")

##Drosophila Genome
dark.green.in.drosophila <- length(RNAseq$ISC[RNAseq$ISC>=50])
not.dark.green.in.drosophila <- length(RNAseq$ISC) - dark.green.in.drosophila

ISC.homeostasis.in.drosophila <- 30
not.ISC.homeostasis.in.drosophila <- length(RNAseq$ISC) - ISC.homeostasis.in.drosophila

## Wheels
esg.wheel <- 1071
dark.green.in.esg.wheel <- 156
ISC.homeostasis.in.esg.wheel <- 8

cic.wheel <- 3692
dark.green.in.cic.wheel <- 550
ISC.homeostasis.in.cic.wheel <- 13 

tis11.wheel <- 308
dark.green.in.tis11.wheel <- 37
ISC.homeostasis.in.tis11.wheel <- 3

## Network
network <- 4458
dark.green.in.network <- 608
not.dark.green.in.network <- network - dark.green.in.network
ISC.homeostasis.in.network <- 14
not.ISC.homeostasis.in.network <- network - ISC.homeostasis.in.network

## Three-way shared subset
three.way.intersect <- 23
dark.green.in.three.way.intersect <- 8
ISC.homeostasis.in.three.way.intersect <- 2

## Traditionally Ranked
dark.green.in.cic.top23 <- 7
dark.green.in.esg.top23 <- 3
dark.green.in.tis11.top23 <- 1
ISC.homeostasis.in.cic.top23 <- 1
ISC.homeostasis.in.esg.top23 <- 0
ISC.homeostasis.in.tis11.top23 <- 0

## pool of traditionally ranked + shared
pool <- 91
dark.green.in.pool <- 18
not.dark.green.in.pool <- pool - dark.green.in.pool
ISC.homeostasis.in.pool <- 2
not.ISC.homeostasis.in.pool <- pool - ISC.homeostasis.in.pool

# Results
## Wheels
dhyper.esg.wheel <- dhyper(dark.green.in.esg.wheel, dark.green.in.drosophila,not.dark.green.in.drosophila, esg.wheel)

dhyper.cic.wheel <- dhyper(dark.green.in.cic.wheel, dark.green.in.drosophila, not.dark.green.in.drosophila, cic.wheel)

dhyper.tis11.wheel <- dhyper(dark.green.in.tis11.wheel, dark.green.in.drosophila, not.dark.green.in.drosophila, tis11.wheel)

dhyper.homeostasis.esg.wheel <- dhyper(ISC.homeostasis.in.esg.wheel, ISC.homeostasis.in.drosophila, not.ISC.homeostasis.in.drosophila, esg.wheel)

dhyper.homeostasis.cic.wheel <- dhyper(ISC.homeostasis.in.cic.wheel, ISC.homeostasis.in.drosophila, not.ISC.homeostasis.in.drosophila, cic.wheel)

dhyper.homeostasis.tis11.wheel <- dhyper(ISC.homeostasis.in.tis11.wheel, ISC.homeostasis.in.drosophila, not.ISC.homeostasis.in.drosophila, tis11.wheel)

## 3-way shared vs Network  AND vs. Drosophila AND vs. pool
dhyper.three.way <- dhyper(dark.green.in.three.way.intersect, dark.green.in.network, not.dark.green.in.network, three.way.intersect)

dhyper.three.way.vs.drosophila <- dhyper(dark.green.in.three.way.intersect, dark.green.in.drosophila, not.dark.green.in.drosophila, three.way.intersect)

dhyper.homeostasis.three.way.vs.network <- dhyper(ISC.homeostasis.in.three.way.intersect, ISC.homeostasis.in.network, not.ISC.homeostasis.in.network, three.way.intersect)

dhyper.homeostasis.three.way.vs.drosophila <- dhyper(ISC.homeostasis.in.three.way.intersect, ISC.homeostasis.in.drosophila, not.ISC.homeostasis.in.drosophila, three.way.intersect)

dhyper.three.way.vs.pool <- dhyper(dark.green.in.three.way.intersect, dark.green.in.pool, not.dark.green.in.pool, three.way.intersect)

dhyper.homeostasis.three.way.vs.pool <- dhyper(ISC.homeostasis.in.three.way.intersect, ISC.homeostasis.in.pool, not.ISC.homeostasis.in.pool, three.way.intersect)

## Traditionally Ranked vs. Network
dhyper.cic.top23 <- dhyper(dark.green.in.cic.top23, dark.green.in.network, not.dark.green.in.network, 23)

dhyper.esg.top23 <- dhyper(dark.green.in.esg.top23, dark.green.in.network, not.dark.green.in.network, 23)

dhyper.tis11.top23 <- dhyper(dark.green.in.tis11.top23, dark.green.in.network, not.dark.green.in.network, 23)

## Traditionally Ranked vs. Drosophila
dhyper.cic.top23.vs.drosophila <- dhyper(dark.green.in.cic.top23, dark.green.in.drosophila, not.dark.green.in.drosophila, 23)

dhyper.esg.top23.vs.drosophila <- dhyper(dark.green.in.esg.top23, dark.green.in.drosophila, not.dark.green.in.drosophila, 23)

dhyper.tis11.top23.vs.drosophila <- dhyper(dark.green.in.tis11.top23, dark.green.in.drosophila, not.dark.green.in.drosophila, 23)

dhyper.homeostasis.cic.top23.vs.drosophila <- dhyper(ISC.homeostasis.in.cic.top23, ISC.homeostasis.in.drosophila, not.ISC.homeostasis.in.drosophila, 23)

dhyper.homeostasis.esg.top23.vs.drosophila <-  dhyper(ISC.homeostasis.in.esg.top23, ISC.homeostasis.in.drosophila, not.ISC.homeostasis.in.drosophila, 23)

dhyper.homeostasis.tis11.top23.vs.drosophila <- dhyper(ISC.homeostasis.in.tis11.top23, ISC.homeostasis.in.drosophila, not.ISC.homeostasis.in.drosophila, 23)

## Traditionally Ranked vs. Pool

dhyper.cic.top23.vs.pool <- dhyper(dark.green.in.cic.top23, dark.green.in.pool, not.dark.green.in.pool, 23)

dhyper.esg.top23.vs.pool <- dhyper(dark.green.in.esg.top23, dark.green.in.pool, not.dark.green.in.pool, 23)

dhyper.tis11.top23.vs.pool <- dhyper(dark.green.in.tis11.top23, dark.green.in.pool, not.dark.green.in.pool, 23)

dhyper.homeostasis.cic.top23.vs.pool <- dhyper(ISC.homeostasis.in.cic.top23, ISC.homeostasis.in.pool, not.ISC.homeostasis.in.pool, 23)

dhyper.homeostasis.esg.top23.vs.pool <-  dhyper(ISC.homeostasis.in.esg.top23, ISC.homeostasis.in.pool, not.ISC.homeostasis.in.pool, 23)

dhyper.homeostasis.tis11.top23.vs.pool <- dhyper(ISC.homeostasis.in.tis11.top23, ISC.homeostasis.in.pool, not.ISC.homeostasis.in.pool, 23)

# Outputs
## Wheels
print(dhyper.cic.wheel)
print(dhyper.esg.wheel)
print(dhyper.tis11.wheel)

print(dhyper.homeostasis.cic.wheel)
print(dhyper.homeostasis.esg.wheel)
print(dhyper.homeostasis.tis11.wheel)

## 3-way shared
print(dhyper.three.way)
print(dhyper.three.way.vs.drosophila)
print(dhyper.three.way.vs.pool)
print(dhyper.homeostasis.three.way.vs.network)
print(dhyper.homeostasis.three.way.vs.drosophila)
print(dhyper.homeostasis.three.way.vs.pool)

## Traditionally Ranked vs. Network
print(dhyper.cic.top23)
print(dhyper.esg.top23)
print(dhyper.tis11.top23)

## Traditionally Ranked vs. Drosophila
print(dhyper.cic.top23.vs.drosophila)
print(dhyper.esg.top23.vs.drosophila)
print(dhyper.tis11.top23.vs.drosophila)

print(dhyper.homeostasis.cic.top23.vs.drosophila)
print(dhyper.homeostasis.esg.top23.vs.drosophila)
print(dhyper.homeostasis.tis11.top23.vs.drosophila)

## Traditionally Ranked vs. Pool
print(dhyper.cic.top23.vs.pool)
print(dhyper.esg.top23.vs.pool)
print(dhyper.tis11.top23.vs.pool)

print(dhyper.homeostasis.cic.top23.vs.pool)
print(dhyper.homeostasis.esg.top23.vs.pool)
print(dhyper.homeostasis.tis11.top23.vs.pool)